﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FaceMonkey
{
    /// <summary>
    /// Previously I had a rubbish blan pair of lips, I am not sure smiling teeth are an improvment.
    /// </summary>
    public partial class mouth_2 : UserControl
    {
        Random random = new Random();

        public mouth_2() {
            InitializeComponent();
            RandomizeAngles(Lower,false);
            RandomizeAngles(Upper,true);
            //sin180();
        }


        // learn about sin results
        private void sin180() {
            for (Double i=90.0; i < 450; i++) {
                System.Diagnostics.Debug.WriteLine(String.Format("sin({0})={1}", i, Math.Sin(Rad(i))));
            }
        }

        /// <summary>
        /// makes the teeth into a smile, with some randomness
        /// </summary>
        /// <param name="root"></param>
        /// <param name="up"></param>
        private void RandomizeAngles(Canvas root, bool up) {
            RotateTransform rt;
            Rectangle r;
            double i =120.0;
            double cHeight;
            foreach (UIElement uie in root.Children) {
                rt = (RotateTransform)uie.RenderTransform;
                rt.Angle = 3-random.Next(6);
                r = (Rectangle)uie;
                r.Height += 5 - random.Next(10);
                cHeight = (double)r.GetValue(Canvas.TopProperty);
                System.Diagnostics.Debug.WriteLine(String.Format("<{0}", cHeight));
                if (up) cHeight = -cHeight* (1 * (1.0 + Math.Sin(Rad(i))));
                else cHeight *= (1 * (1.0 + Math.Sin(Rad(i))));
                System.Diagnostics.Debug.WriteLine(String.Format(">{0}", cHeight));
                r.SetValue(Canvas.TopProperty, cHeight);
                i += 40.0;
            }
        }

        /// <summary>
        /// result as radians
        /// </summary>
        /// <param name="p"></param>
        /// <returns></returns>
        private double Rad(double p) {
            return (p * Math.PI / 180);
        }
    }
}
