﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FaceMonkey
{
    /// <summary>
    /// shows animation in background and bubbles click event
    /// </summary>
    public partial class AboutPage : UserControl
    {
       public delegate void MouseUp_EventHandler(object sender, MouseButtonEventArgs e);
        public event MouseUp_EventHandler MouseUp_Event;

        public AboutPage() {
            InitializeComponent();
        }

        private void DoubleAnimation_Completed(object sender, EventArgs e) {
            animBg1.Begin();
            animBg2.Begin();
            animBg3.Begin();
        }

        private void Rectangle_MouseLeftButtonUp(object sender, MouseButtonEventArgs e) {
            MouseUp_Event(this, null);
        }
    }
}
