﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace FaceMonkey
{
    public partial class Page : UserControl
    {
        /// <summary>
        /// Dynamically add each class as a button into the grid and apply mouse events
        /// </summary>
        private void AddButtons() {
            int row = 0;
            ButtonContainer bc;
            bc = new ButtonContainer(new hat_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "H1"));
            bc = new ButtonContainer(new hat_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "H2"));
            bc = new ButtonContainer(new hat_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "H3"));
            bc = new ButtonContainer(new hat_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "H4"));
            row++;
            bc = new ButtonContainer(new eye_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "E1"));
            bc = new ButtonContainer(new eye_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "E2"));
            bc = new ButtonContainer(new eye_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "E3"));
            bc = new ButtonContainer(new eye_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "E4"));
            row++;
            bc = new ButtonContainer(new nose_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "N1"));
            bc = new ButtonContainer(new nose_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "N2"));
            bc = new ButtonContainer(new nose_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "N3"));
            bc = new ButtonContainer(new nose_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "N4"));
            row++;
            bc = new ButtonContainer(new glasses_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "G1"));
            bc = new ButtonContainer(new glasses_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "G2"));
            bc = new ButtonContainer(new glasses_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "G3"));
            bc = new ButtonContainer(new glasses_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "G4"));
            row++;
            bc = new ButtonContainer(new ear_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "R1"));
            bc = new ButtonContainer(new ear_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "R2"));
            bc = new ButtonContainer(new ear_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "R3"));
            bc = new ButtonContainer(new ear_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "R4"));
            row++;
            bc = new ButtonContainer(new mouth_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "M1"));
            bc = new ButtonContainer(new mouth_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "M2"));
            bc = new ButtonContainer(new mouth_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "M3"));
            bc = new ButtonContainer(new mouth_4());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "M4"));
            row++;
            bc = new ButtonContainer(new other_1());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "O1"));
            bc = new ButtonContainer(new other_2());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "O2"));
            bc = new ButtonContainer(new other_3());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "O3"));
            bc = new ButtonContainer(new facemonkey());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "O4"));
            row++;
            Ellipse e;
            Double Diameter = 5;
            for (int i = 0; i < 4; i++) {
                e = new Ellipse();
                e.Fill = new SolidColorBrush(Colors.Black);
                e.Width = Diameter;
                e.Height = Diameter;
                e.SetValue(Grid.RowProperty, row);
                e.SetValue(Grid.ColumnProperty, i);
                Diameter += 5;
                bc = new ButtonContainer();
                bc.SetValue(Grid.RowProperty, row);
                bc.SetValue(Grid.ColumnProperty, i);
                GridButton.Children.Add(bc);
                GridButton.Children.Add(e);
                GridButton.Children.Add(MaskButton(bc, String.Format("S{0}", i)));
            }
            row++;
            int column = 0;
            Rectangle r;
            r = new Rectangle();
            r.Width = Diameter;
            r.Height = Diameter;
            r.Fill = new SolidColorBrush(Colors.Black);
            bc = new ButtonContainer();
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, column);
            r.SetValue(Grid.RowProperty, row);
            r.SetValue(Grid.ColumnProperty, column);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(r);
            GridButton.Children.Add(MaskButton(bc, String.Format("C{0}", column)));
            column++;
            r = new Rectangle();
            r.Width = Diameter;
            r.Height = Diameter;
            r.Fill = new SolidColorBrush(Colors.Red);
            bc = new ButtonContainer();
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, column);
            r.SetValue(Grid.RowProperty, row);
            r.SetValue(Grid.ColumnProperty, column);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(r);
            GridButton.Children.Add(MaskButton(bc, String.Format("C{0}", column)));
            column++;
            r = new Rectangle();
            r.Width = Diameter;
            r.Height = Diameter;
            r.Fill = new SolidColorBrush(Colors.Blue);
            bc = new ButtonContainer();
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, column);
            r.SetValue(Grid.RowProperty, row);
            r.SetValue(Grid.ColumnProperty, column);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(r);
            GridButton.Children.Add(MaskButton(bc, String.Format("C{0}", column)));
            column++;
            r = new Rectangle();
            r.Width = Diameter;
            r.Height = Diameter;
            r.Fill = new SolidColorBrush(Colors.Green);
            bc = new ButtonContainer();
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, column);
            r.SetValue(Grid.RowProperty, row);
            r.SetValue(Grid.ColumnProperty, column);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(r);
            GridButton.Children.Add(MaskButton(bc, String.Format("C{0}", column)));
            row++;
            bc = new ButtonContainer(new CaligControl());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q0"));
            bc = new ButtonContainer(new Load());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q3"));
            bc = new ButtonContainer(new LoadVideo());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q4"));
            bc = new ButtonContainer(new Cheese());
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q7"));
            row++;
            bc = new ButtonContainer(new RotateControl(-1.0));
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 0);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q1"));
            bc = new ButtonContainer(new RotateControl(1.0));
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 1);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q2"));
            bc = new ButtonContainer(new FlipFlop(true));
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 2);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q5"));
            bc = new ButtonContainer(new FlipFlop(false));
            bc.SetValue(Grid.RowProperty, row);
            bc.SetValue(Grid.ColumnProperty, 3);
            GridButton.Children.Add(bc);
            GridButton.Children.Add(MaskButton(bc, "Q6"));
        }

        const String ButtonPrefix = "BC__";

        /// <summary>
        /// 
        /// </summary>
        /// <param name="bc">ButtonContainer object to work with</param>
        /// <param name="Name">Unique name</param>
        /// <returns>UIElement that is a ButtonContainer with an invisible rectange for mouse events overlayed</returns>
        private UIElement MaskButton(ButtonContainer bc, string Name) {
            bc.Name = String.Format("{0}{1}", ButtonPrefix, Name);
            Rectangle r = new Rectangle();
            r.Width = bc.Width;
            r.Height = bc.Height;
            r.Fill = new SolidColorBrush(Colors.Transparent);
            r.SetValue(Grid.RowProperty, bc.GetValue(Grid.RowProperty));
            r.SetValue(Grid.ColumnProperty, bc.GetValue(Grid.ColumnProperty));
            r.Name = Name;
            r.MouseLeftButtonUp += new MouseButtonEventHandler(AddButton_Click);
            // handle mouse overs
            r.MouseEnter += new MouseEventHandler(AddButton_MouseEnter);
            r.MouseLeave += new MouseEventHandler(AddButton_MouseLeave);
            return ((UIElement)r);
        }

        // initiate a fade in
        void AddButton_MouseEnter(object sender, MouseEventArgs e) {
            Rectangle r = (Rectangle)sender;
            Fade(r.Name, true);
        }

        // initiate a fade out
        void AddButton_MouseLeave(object sender, MouseEventArgs e) {
            Rectangle r = (Rectangle)sender;
            Fade(r.Name, false);
        }

        /// <summary>
        /// start the fade in or out animations of the respective ButtonContainer found
        /// </summary>
        /// <param name="p"></param>
        /// <param name="p_2"></param>
        private void Fade(string Name, bool fadein) {
            String BCName = String.Format("{0}{1}", ButtonPrefix, Name);
            ButtonContainer bc = (ButtonContainer)GridButton.FindName(BCName);
            if (fadein) bc.FadeIn.Begin();
            else bc.FadeOut.Begin();
        }
    }
}
